#ifndef GERTBOT_DCCSETUP_H
#define GERTBOT_DCCSETUP_H

#include <QtGui/QDialog>
#include "ui_dccsetup.h"

#include <qfiledialog.h>
#include <qmessagebox.h>
#include <stdio.h>
#include <QButtonGroup>

typedef struct {
 char *name;
 int  board;
 int  motor;
 int  destination[11];
 char pb_text[11][16];
 char pb_command[11][128];
 int   cmnd_length[11];
 unsigned char command[11][64];
 int   slider_number_pos;
 int   slider_number_data;
 int   slider_min,slider_max;
} dccsetup_type;

class gertbot_dccsetup : public QDialog
{
    Q_OBJECT

public:
    gertbot_dccsetup(QWidget *parent = 0, Qt::WFlags flags = 0);
    ~gertbot_dccsetup();
    Ui::dccsetup ui;
    void set_dcc(dccsetup_type *this_dcc,dccsetup_type *all_dcc);
    void get_dcc(dccsetup_type *this_dcc);
//    void add_dccsetup(QString str);

private:
  int save_dcc(FILE *fp,dccsetup_type *dccs);
  int load_dcc(FILE *fp,dccsetup_type *dccs);
  dccsetup_type local_dcc;
  dccsetup_type *parent_dcc;
  QButtonGroup  ub;
  int cur_but; // current button 
  int dcc_str_to_bin(unsigned char *buffer,QString str,char *legal);
  QString last_dcc_dir,dcc_filename;
  bool help_screen;
  QMessageBox message_box;   

public slots:
     void file_slot(int);
     void pb_slot(int);
     void done_slot();
     void help_slot();
};

#endif // GERTBOT_DCCSETUP_H
