//
// Gertbot GUI
//
// Primitive (modeless) log file window 
//

#include "gertbot_log.h"
#include "gertbot_defines.h"

extern int log_show_reply;

gertbot_log::gertbot_log(QWidget *parent, Qt::WFlags flags)
    : QDialog(parent, flags)
{
  ui.setupUi(this);
  connect(this  ,SIGNAL(finished(int)), parent, SLOT(log_close_slot()));
  connect(ui.pd_saveas  ,SIGNAL(activated(int)), this, SLOT(saveas_slot(int)));
  connect(ui.cb_show_reply  ,SIGNAL(toggled(bool)), this, SLOT(show_reply_slot(bool)));
  //  connect 

}

gertbot_log::~gertbot_log()
{
 
}


//
// very primitive log window
//
void gertbot_log::add_log(QString str)
{ int lines;
  ui.te_log->appendPlainText(str);
  // Primitive limit log
  lines = ui.te_log->document()->lineCount();
  if (lines>300)
  { // remove top 50 lines
    ui.te_log->moveCursor(QTextCursor::Start);
    for (lines=0; lines<50; lines++)
      ui.te_log->moveCursor(QTextCursor::Down, QTextCursor::KeepAnchor);
    ui.te_log->cut(); 
    ui.te_log->moveCursor(QTextCursor::End);
  }
} // add_log

void gertbot_log::saveas_slot(int format)
{
  QString fileName = QFileDialog::getSaveFileName(this);
  if (fileName.isEmpty())
    return; // user gave no name: no saving!
  save_log_file(fileName,format);
} // save_as


void gertbot_log::save_log_file(QString filename,int mode)
{ FILE *fp;
  QString mess;
  QString plainTextEditContents;
  QStringList all_lines;
  int line,lines,length;
  char trans_store[128];
  if (mode==0)
    fp = fopen(filename.toLatin1(),"w");
  else
    fp = fopen(filename.toLatin1(),"wb");
  if (!fp)
  { mess= "Can't open '"+filename+"' for writing";
  //mess.sprintf("Can't open '%s' for writing",filename.toLatin1());
    QMessageBox::warning(this, "QEdit",mess);
    return;  
  }
  plainTextEditContents = ui.te_log->toPlainText();
  all_lines = plainTextEditContents.split("\n");
  lines = all_lines.count();
  for (line=0; line<lines; line++)
  {
    if (mode==0)
    { fputs(all_lines[line].toLatin1(),fp);
      fputc(0x0a,fp);
    }
    else
    { length = translate(trans_store,all_lines[line]);
      if (length)
        fwrite(trans_store,1,length,fp);
    }
  }
  fclose(fp);
} // save_log_file
 
int  gertbot_log::translate(char *store,QString line)
{ int s,l,i,ls,ms;
  s= 0 ;
  store[s++] = (char)CMD_START_VAL;
  l = line.length();

  // Assuming known text format
  // On any error return 0 
  i = 0;
  while (i<l)
  { while (i<l && line[i]==' ')
      i++;
    if (line[i++]!='0')
      return 0;
    if (line[i++]!='x')
      return 0;
    ms = line[i++].toAscii()-'0';
    if (ms>9)
      ms -= 7;
    ls = line[i++].toAscii()-'0';
    if (ls>9)
      ls -= 7;
    store[s++] = ms * 16 + ls;
  }
  store[s++] = CMD_STOP_VAL;
  return s;
} // translate

void  gertbot_log::show_reply_slot(bool on)
{
  log_show_reply = on ? 1 : 0;
}

